﻿using System.Collections.Generic;

namespace TemplateMethodFindSmallest
{
    public abstract class AbstractFindSmallest<T>
    {
        public T DoIt(IEnumerable<T> elements)
        {
            T smallestSoFar = default(T);
            bool first = true;
            foreach (T element in elements)
            {
                if (first)
                {
                    smallestSoFar = element;
                    first = false;
                }
                else if (Compare(smallestSoFar, element) > 0)
                {
                    smallestSoFar = element;
                }
            }
            return smallestSoFar;
        }

        protected abstract int Compare(T a, T b);
    }
}
